Redmine - Defect #30257

include/child_pages macro documentation typo
2018-12-20 14:11 - Guillermo ML

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Website (redmine.org) Estimated time: 0.00 hour
Target version:

Resolution: Duplicate Affected version: 3.44
Description

At the Textile formatting wiki page it says that the syntax for include macro is:

'{{include (Foo) }}
but in our 3.4.4.stable server (or www.redmine.org) it seems that the first character "!" is wrong, without it works fine.

Same with child_pages macro:

'{{child_pages}}

without the "!" mark works fine.

see examplesee example

Textile formatting

Below is Textile formatting. For Markdown formatting see RedmineTextFormattingMarkdown.
For limitations of current Textile support see #6269, #10078 (Definition Lists).

Links

Redmine links

Redmine allows hyperlinking between resources (wiki pages, issues, documents...) from anywhere text formatting is used.
Wiki links:

e [[Guide]] displays a link to the page named 'Guide': Guide

¢ [[Guide#further-reading]] takes you to the anchor "further-reading". Headings get automatically assigned anchors so that
you can refer to them: Guide

¢ [[Guide|User manual]] displays a link to the same page but with different text: User manual

¢ [[Guide#User-guide|User guide]] displays a link to the header on the same page with different text: User guide

You can also link to pages of another project's wiki (using the project identifier):

¢ [[sandbox:some page]] displays a link to the page named 'Some page' of the Sandbox wiki
¢ [[sandbox:]] displays a link to the Sandbox wiki main page

Wiki links are displayed in red if the page doesn't exist yet, eg: Nonexistent page.
Links to other resources:
* [ssues:

o #124 (link to an issue: displays #124, link is striked-through if the issue is closed)
° #124-6, or #124#note-6 (link to an issue note: displays #124-6, or #1244#note-6)
® Documents:
o document#17 (link to document with id 17)
o document:Greetings (link to the document with title "Greetings")
o document:"Some document" (double quotes can be used when document title contains spaces)
o sandbox:document:"Some document” (link to a document with title "Some document” in project identifier
"sandbox")

e Versions:
o version#3 (link to version with id 3)
o version:1.0.0 (link to version named "1.0.0")
o version:"1.0 beta 2" (double quotes can be used when version name contains spaces)
o sandbox:version:1.0.0 (link to version "1.0.0" in the project identifier "sandbox")

e Attachments:
o attachment:file.zip (link to the attachment of the current object named file.zip)
o attachment:"file name.zip" (double quotes can be used when the filename contains non word characters)
o For now, attachments of the current object can be referenced only (if you're on an issue, it's possible to reference
attachments of this issue only)

¢ Changesets:

o r758 (link to a changeset, displays r758)
commit:c6f4d0fd (link to a changeset with a non-numeric hash)
svn1|r758 (link to a changeset of a specific repository, for projects with multiple repositories)
commit:hg|c6f4d0fd (link to a changeset with a non-numeric hash of a specific repository)
sandbox:r758 (link to a changeset of another project)
sandbox:commit:c6f4d0fd (link to a changeset with a non-numeric hash of another project identifier)

O O O O ©

¢ Repository files:
o source:some/file (link to the file located at /some/file in the project's repository)
source:"some file" (link to the file with non word characters in the path)
source:some/file@52 (link to the file's revision 52)
source:some/file@master (link to the file in branch master)
source:some/file#L120 (link to line 120 of the file)
source:some/file@52#L120 (link to line 120 of the file's revision 52)
source:repo_identifier|some/file (link to a file of a specific repository, for projects with multiple repositories)
sandbox:source:some/file (link to the file in the project identifier "sandbox")
sandbox:source:repo_identifier|some/file (link to the file, with non word characters in the path, of a specific
repository in the project identifier "sandbox")
o export:some/file (force the download of the file)

o 0O 0O O O O O O

e Forums:
o forum#2 (link to forum with id 2)
o forum:Discussion (link to forum with name "Discussion")
o forum:"Help and more" (double quotes can be used when forum name contains spaces)

e Forum messages:
o message#1218 (link to message with id 1218)

* News items
o news#1 (link to news item with id 1)
o news:Greetings (link to news item with name "Greetings")
o news:"eCookbook first release !" (double quotes can be used when news item name contains spaces)

¢ Projects:
o project#3 (link to project with id 3)
o project:someproject (link to project with name "someproject”)
o project:"Multiple words project” (double quotes can be used when project name contains spaces)

e Users:
o Thomas Lecavelier (link to user with id 2)
o user:jsmith (Link to user with login "jsmith")
o @jsmith (Link to user with login "jsmith")

Escaping:

¢ You can prevent Redmine links from being parsed by preceding them with an exclamation mark: !
External links

URLSs (http, https, ftp and ftps) are automatically turned into clickable links:

¢ http://www.redmine.org -- External link to the redmine website: http://www.redmine.org

URLs can also use different text than the link itself:
¢ "Redmine web site":http://www.redmine.org -- External link with different text: Redmine web site
o lhttp://www.redmine.org/attachments/7069/Redmine_logo.png(Redmine web site)!:http://www.redmine.org --
External image with a title that links to an URL:

_ Redmine_logo.png

File URI can be used to link UNC path:

* "\\server\share$":file://///server/share%24 -- File URI showing UNC path: \\server\share$
You should URL Encodings for special characters like empty space, $, 4, é, 1, 6, 0, etc.

Email addresses
Email addresses are automatically turned into clickable links:

* someone@foo.bar -- Link to an email address: someone@foo.bar
¢ "Email someone":mailto:someone@foo.bar -- Email link with different text: Email someone

More complex email instructions can be added to an email link. A default subject, default body and CC information can be
defined. Note that spaces in any of these fields need to be replaced with the code %20.

* "Email webmaster and admin':mailto:webmaster@foo.bar?cc=admin@foo.bar -- Email to webmaster, CC admin:
Email webmaster and admin

¢ "Email someone for help":mailto:someone@foo.bar?subject=Website%20Help -- Email link with the subject "Website
Help": Email someone for help

¢ "Email someone for help":mailto:someone@foo.bar?subject=Website%20Help&body=My%20problem%20is%20 --
Email link with the subject "Website Help" and a default body: My problem is

Text formatting

For things such as headlines, bold, tables, lists, Redmine supports Textile syntax. See http://redcloth.org/hobix.com/textile/ for
information on using any of these features. A few samples are included below, but the engine is capable of much more of that.

Acronym

JPL (Jean-Philippe Lang)
displays:

JPL

Font style

* *phold*

_italic_

*_bold italic_*
+underline+

*

*

—-strike-through-
Plain “superscript”

E O S S

Plain ~subscript~

* @inline monospace@

* normal *bold* _italic_ normal;E=mc "2%

* normal<notextile></notextile>*bold*<notextile></notextile> italic_<notextile></notextile>nor
mal; E=mc<notextile></notextile>"2"

* Escaping: <notextile>*bold* _italic_ @inlinemono@</notextile> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
Alternative using HTML-codes: &#42;bold&#42; &#95;italic&#95; &#64;inlinemono&#64;

* <pre>*some lines* some "link":http://www.redmine.org</pre>

* <pre><notextile></notextile>*some lines* some "link":http://www.redmine.org</pre>
displays:

bold

italic

bold italic
underline

e Plain superscript

* Plain subscript

* inline monospace

« normal bold italic normal;E=mc 2

« normalbolditalicnormal;E=mc?

¢ Escaping: *bold* _italic_ @inlinemono@ Alternative using HTML-codes: *bold* _italic_ @inlinemono@

- I
- B v i

Color

* %{color:red}red% %{color:green}tgreen% %${color:yellow}yellow% $%${color:#82B6El}blue'ish$%

* %{color:red}red%<notextile></notextile>%{color:green}tgreen%<notextile></notextile>%{color:ye
llow}yellow%<notextile></notextile>%{color:#82B6El}blue'ish%

* %{background:lightgreen}Lightgreen Background% $%{background:yellow}Yellow Background$%

* %{background:lightgreen}Lightgreen Background%<notextile></notextile>%{background:yellow}Yel
low Background$%

displays:

red green
redgreen
Lightgreen Background Yellow Background
Lightgreen BackgroundYellow Background

Inline images
¢ limage_url! displays an image located at image_url (textile syntax)
¢ !>image_url! right floating image
¢ limage_url(Image title)! displays an image with an alt/title attribute
* limage_url!:URL displays an image located at image_url with link URL added

If you have an image attached to your wiki page, it can be displayed inline using its filename: !attached_image.png!

You can also apply a CSS style to the image in the same ways as styling SPANs. The code {width:
100%}attached_image.png! will make the image adjusts to the parent's width.

Headings

hl. Heading

h2. Subheading

h3. Subheading

Redmine assigns an anchor to each of those headings thus you can link to them with "#Heading", "#Subheading" and so forth.
Paragraphs

p. left aligned

p(. left ident lem

p((. left ident 2em
as well as for following lines
p>. right aligned

p)))>. right ident 3em

p=. This is centered paragraph.
displays;

left aligned

left ident 1em

left ident 2em
as well as for following lines

right aligned
right ident 3em
This is centered paragraph.
Horizontal rule

displays:

Preformatted Text
<pre>*Your text won't become bold*</pre>
displays:
*Your text won't become bold*
Blockquotes
Start the paragraph with bq.:
bg. Rails is a full-stack framework for developing database-backed web applications according
to the Model-View-Control pattern.
To go live, all you need to add is a database and a web server.
displays:
Rails is a full-stack framework for developing database-backed web applications according to the Model-View-Control
pattern.
To go live, all you need to add is a database and a web server.
You can also use > at the beginning of each line and stack them for nested quotes:
>> Rails is a full-stack framework for developing database-backed web applications according t
o the Model-View-Control pattern.
>> To go live, all you need to add is a database and a web server.
> Great!
displays:
Rails is a full-stack framework for developing database-backed web applications according to the Model-View-Control

pattern.
To go live, all you need to add is a database and a web server.
Great!

Unordered lists

* Ttem 1
* ITtem 2
** Ttem 21
** Ttem 22
* Item 3

displays:

e |tem 1
* [tem 2
o ltem 21
o ltem 22
e [tem 3

Ordered lists

# Item 1
# Item 2
# Item 3
## Item 3.1
## Item 3.2
displays:

1. ltem 1

2. ltem 2

3.ltem 3

1. ltem 3.1
2. ltem 3.2
Tables
|_.UserID | _.Name | _.Group
|Starting with | a | simple
I\3=.1IT
|1 |Artur Pirozhkov |/2.Users
|2 |Vasya Rogov =. center
|3 | John Smith |Admin
(root)

| 4 |- | Nobody

(anonymous)

displays (all multiple spaces are replaced by 1 space):

<.
>

| N

. attribute list
| row

align left
align right

. valign top

. valign bottom

UserID Name Group attribute list
Starting with a simple row
IT align left

1 Artur Pirozhkov Users align right
2 Vasya Rogov center
3 John Smith Admin valign top

(root)
4 - Nobody valign bottom

(anonymous)

If you want to include pipe characters inside your table (e.g. for Wiki links), you need to prevent textile from interpreting them:
Input Output

<notextile>|</notextile>

If you want to specify the width of the table, you need to put table{width:100%]}. just before your table definition:
table{width:100%}.
| This table will use

all horizontal space |

This way the table will extend to the whole page width ...

This table will use
all horizontal space

... compared with the standard width:

This table will use
only the required space

Special table control sequences

The order of the table control sequences is fixed. If two order are equal then the precedence of the sequences is equal.
If the table control sequences are used in the wrong order, they will not be interpreted.

Sequence Ord Function

—_

Highlight the contents of the cell

Merge n cells horizontally

Merge n cells vertically

Allign text to left

Allign text to center

Allign text to right

Allign text to top

Allign text to bottom

\
AW W[W|W|lW[NM]N

Control sequence terminator

Table of content

{{toc}} => left aligned toc
{{>toc}} => right aligned toc

Please keep in mind, that the toc-tag needs an empty line above and underneath it and no other text before and after it.
Example:

hl. headLineOne

h2. something

{{toc}}

h2. something more

Footnotes

Marker:
This is a first word[l] with a footnote.

This is a second word[2] with a footnote.

Note: Marker directly attached to word (no space, no dot or any thing else in between).

Definition:

fnl. Footnote for the first word

fn2. Footnote for the second word

Note: Each definition on its own line anywhere within the document. Empty lines between definitions.
displays:

This is a first word" with a footnote.

This is a second word? with a footnote.
' Footnote for the first word

2 Footnote for the second word

Macros

Redmine includes a macros system that lets you add custom functions to insert dynamic content in formatted text. You can
learn about writing your own macros in RedmineMacros. Redmine also includes a few builtin macros:

hello_world

Sample macro.

macro_list

Displays a list of all available macros, including description if available.

child_pages

Displays a list of child pages. With no argument, it displays the child pages of the curre

nt wiki page. Examples:

{{child_pages}} —-—- can be used from a wiki page only

{{child_pages (depth=2)}} —-- display 2 levels nesting only

{{child_pages (Foo)}} —-—- lists all children of page Foo
{{child_pages (Foo, parent=1l)}} —-- same as above with a link to page Foo

include
Includes a wiki page. Examples:
{{include (Foo) }}

{{include (projectname:Foo) }} —— to include a page of a specific project wiki

collapse
Inserts of collapsed block of text. Examples:
{{collapse

This is a block of text that is collapsed by default.
It can be expanded by clicking a link.

}}

{{collapse (View details...)
With custom link text.
I

thumbnail

Displays a clickable thumbnail of an attached image.
Default size is 200 pixels. Examples:
{{thumbnail (image.png) }}

{{thumbnail (image.png, size=300, title=Thumbnail) }}

issue

Displays an issue link including additional informati
{{issue (123)}}

{{issue (123, project=true) }}
ilities
{{issue (123,
{{issue (123,

Issue

tracker=false) }}
subject=false, project=true) }}

-— #123:

sample_macro

Sample macro

Code highlighting

—— Andromeda - Issue #123:

—-— with custom title and size

on. Examples:

#123: Enhance macro capabilities

Enhance macro capab

Enhance macro capabilities

—— Andromeda - Issue #123

Default code highlightment relies on Rouge, a syntax highlighting library written in pure Ruby. It supports many commonly used

languages such as ¢, cpp (c++), csharp (c#, cs), css, diff (patch, udiff), go (

golang), groovy, html, java, javascript (js), kotlin

, objective_c (objc), perl (pl), php, python (py), r, ruby (rb), sass, scala, shell (bash, zsh, ksh, sh), sql, swift, xml and yaml
(yml) languages, where the names inside parentheses are aliases. Please refer to RedmineCodeHighlightingLanguages for the

full list of supported languages.
You can highlight code in your wiki page using this syntax:

<pre><code class="ruby">
Place your code here.
</code></pre>

Example:

# The Greeter class
class Greeter
def initialize (name)
@name
end

name.capitalize

def salute
puts "Hello #{Q@name}!"
end
end
Styling text using CSS

Textile can style text using CSS. Examples as follows:

Three primary colors of light are %${color: #f00}red%, %{color: #0fO}green% and %{color: #00f}b

lue%.
p{border: solid lpx #000; padding: 0.5em;}. The quick brown fox jumps over the lazy dog.

table{width: 100%}.
|={width: 30%; background-color: #aaf;}. column 1 |={width: 70%}. column 2 |

displays:
Three primary colors of light are red, and blue.

The quick brown fox jumps over the lazy dog.

column 1 column 2

Allowed CSS properties
Redmine allows the following properties. Other properties are not allowed for security reasons (see r2192).

e background
e background-*
e border
border-*
color

float

font

font-*
height
margin
margin-*
max-height
max-width
min-height
min-width
padding
padding-*
text

e text-*

¢ width

Translation
Note that the following translations may not be up to date. Please refer to the original english documentation if needed.

e Portugués Brasileiro

e Pycckuin
French

00(Korean)

Related issues:
Related to Redmine - Defect #19002: Typos in descriptions of buildin macros (... Closed

History
#1 - 2018-12-20 16:44 - Bernhard Rohloff

That's because in the documentation the macros description in the wiki is shown by the {{macro_list}} macro and the syntax of the child_pages macro
has changed since 2014.

It is perhaps a better idea to create the documentation of the macros by hand.

#2 - 2019-10-24 02:46 - Go MAEDA
- Category changed from Documentation to Website (redmine.org)
- Status changed from New to Closed

- Resolution set to Duplicate

This is due to a bug of {{macro_list}} macro fixed in Redmine 2.6.3 (#19381). The website will be fixed when redmine.org is updated to the latest
version.

| am closing this issue as a duplicate of #19002.

#3 - 2019-10-24 02:46 - Go MAEDA
- Related to Defect #19002: Typos in descriptions of buildin macros (seen through {{macro_list}} output) added
